## ros-dashing-realsense2-camera 3.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(realsense2_camera)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()
option(BUILD_WITH_OPENMP "Use OpenMP" OFF)
option(SET_USER_BREAK_AT_STARTUP "Set user wait point in startup (for debug)" OFF)

# Compiler Defense Flags
if(UNIX OR APPLE)
  # Linker flags.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    # GCC specific flags. ICC is compatible with them.
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z noexecstack -z relro -z now")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z noexecstack -z relro -z now")
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    # In Clang, -z flags are not compatible, they need to be passed to linker via -Wl.
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
  endif()

  # Compiler flags.
  if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    # GCC specific flags.
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.9 OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.9)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector-strong")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector")
    endif()
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    # Clang is compatbile with some of the flags.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIE -fstack-protector")
  elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    # Same as above, with exception that ICC compilation crashes with -fPIE option, even
    # though it uses -pie linker option that require -fPIE during compilation. Checksec
    # shows that it generates correct PIE anyway if only -pie is provided.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector")
  endif()

  # Generic flags.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -fno-operator-names -Wformat -Wformat-security -Wall")
  # Dot not forward c++ flag to GPU beucause it is not supported
  set( CUDA_PROPAGATE_HOST_FLAGS OFF )
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -D_FORTIFY_SOURCE=2")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if (${uppercase_CMAKE_BUILD_TYPE} STREQUAL "RELEASE")
    message(STATUS "Create Release Build.")
    set(CMAKE_CXX_FLAGS "-O2 ${CMAKE_CXX_FLAGS}")
else()
    message(STATUS "Create Debug Build.")
endif()

if(BUILD_WITH_OPENMP)
    find_package(OpenMP)
    if(NOT OpenMP_FOUND)
        message(FATAL_ERROR "\n\n OpenMP is missing!\n\n")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -fopenmp")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
    endif()
endif()

if(SET_USER_BREAK_AT_STARTUP)
	message("GOT FLAG IN CmakeLists.txt")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBPDEBUG")
endif()


find_package(ament_cmake REQUIRED)
find_package(builtin_interfaces REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(image_transport REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(realsense2_camera_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(tf2 REQUIRED)

find_package(realsense2 2.45.0)
if(NOT realsense2_FOUND)
    message(FATAL_ERROR "\n\n Intel RealSense SDK 2.0 is missing, please install it from https://github.com/IntelRealSense/librealsense/releases\n\n")
endif()

#set(CMAKE_NO_SYSTEM_FROM_IMPORTED true)
include_directories(include)

set(node_plugins "")

set(SOURCES 
    src/realsense_node_factory.cpp
    src/base_realsense_node.cpp
    src/t265_realsense_node.cpp
    src/dynamic_params.cpp
  )

if(NOT DEFINED ENV{ROS_DISTRO})
  message(FATAL_ERROR "ROS_DISTRO is not defined." )
endif()
if("$ENV{ROS_DISTRO}" STREQUAL "dashing")
  message(STATUS "Build for ROS2 Dashing")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDASHING")
  set(SOURCES "${SOURCES}" src/ros_param_backend_dashing.cpp)
elseif("$ENV{ROS_DISTRO}" STREQUAL "eloquent")
  message(STATUS "Build for ROS2 eloquent")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DELOQUENT")
  set(SOURCES "${SOURCES}" src/ros_param_backend_foxy.cpp)
elseif("$ENV{ROS_DISTRO}" STREQUAL "foxy")
  message(STATUS "Build for ROS2 Dashing")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DFOXY")
  set(SOURCES "${SOURCES}" src/ros_param_backend_foxy.cpp)
else()
  message(FATAL_ERROR "Unsupported ROS Distribution: " "$ENV{ROS_DISTRO}")
endif()


add_library(${PROJECT_NAME} SHARED
    include/constants.h
    include/realsense_node_factory.h
    include/base_realsense_node.h
    include/dynamic_params.h
    include/ros_param_backend.h
    ${SOURCES}
)

target_link_libraries(${PROJECT_NAME}
    ${realsense2_LIBRARY}
    )

set(dependencies 
  cv_bridge
  image_transport
  rclcpp
  rclcpp_components
  realsense2_camera_msgs
  std_msgs
  std_srvs
  sensor_msgs
  nav_msgs
  tf2
  realsense2
  tf2_ros
)

ament_target_dependencies(${PROJECT_NAME}
  ${dependencies}
)

rclcpp_components_register_node(${PROJECT_NAME}
  PLUGIN "realsense2_camera::RealSenseNodeFactory"
  EXECUTABLE realsense2_camera_node
)

# Install binaries
install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# Install headers
install(
  DIRECTORY include/
  DESTINATION include
)

# Install launch files
install(DIRECTORY 
    launch
    config
    DESTINATION share/${PROJECT_NAME}
    )

# Test
if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(OpenCV REQUIRED)

  ament_lint_auto_find_test_dependencies()

  set(REALSENSE_DEVICE_PLUGIN FALSE)
  if(${REALSENSE_DEVICE_PLUGIN})
    ament_add_gtest(test_api test/test_api.cpp)
  endif()
  if(TARGET test_api)
    target_include_directories(test_api PUBLIC
      ${${PROJECT_NAME}_INCLUDE_DIRS}
    )
  ament_target_dependencies(test_api
    OpenCV
    rclcpp
    sensor_msgs
    nav_msgs
    tf2
    tf2_ros)
  endif()
endif()

# Ament exports
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(${dependencies})

ament_package()

=== debian/changelog ===
ros-dashing-realsense2-camera (3.2.1-1bionic) bionic; urgency=high

  * Add build dependency **ros_environment**
  * Contributors: doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Sun, 09 May 2021 21:00:00 -0000

ros-dashing-realsense2-camera (3.2.0-1bionic) bionic; urgency=high

  * Added filling correct Tx, Ty values in projection matrix of right camera.
  * Fixed frame_id of right sensor to match left sensor in a stereo pair.pair
  * Contributors: Pavlo Kolomiiets, doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 04 May 2021 21:00:00 -0000

ros-dashing-realsense2-camera (3.1.6-1bionic) bionic; urgency=high

  * Fix pointcloud message size when no texture is added.
  * migration toggle_sensors feature to ros2
  * Add option for aligning pointcloud to color image.
  * removed option to align to other streams other then color.
  * Contributors: anaelle, doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 04 May 2021 21:00:00 -0000

ros-dashing-realsense2-camera (3.1.5-1bionic) bionic; urgency=high

  * Support Eloquent and Dashing.
  * Add filter: HDR_merge
  * fix initialization of colorizer image if user specified negative image size (as is in default launch file)
  * Remove the following tests for known playback issue with librealsense2 version 2.43.0: align_depth_color_1, align_depth_ir1_1, align_depth_ir1_decimation_1.
  * Remove wrong dependency
  * changed default image QOS to SYSTEM_DEFAULT
  * Add missing librealsense2 dependency from package.xml
  * fix bug: selection of profile disregarded stream index.
  * Contributors: changseung.yu, doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 23 Mar 2021 22:00:00 -0000

ros-dashing-realsense2-camera (3.1.4-1bionic) bionic; urgency=high

  * fix reading json file with device other than D400 series.
  * Publish depth confidence image for supporting devices (L515)
  * Add selecting QoS option
  * Import unit-tests
  * fix timestamp domain issues
    - Add offset to ros_time only if device uses hardware-clock. Otherwise use device time - either system_time or global_time.
    - Warn of a hardware timestamp possible loop.
  * Choose the default profile in case of an invalid request.
  * Avoid aligning confidence image.
  * Add an option for an Ordered PointCloud.
  * Contributors: Gabriel Urbain, Isaac I.Y. Saito, Itamar Eliakim, Marc Alban, doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Wed, 17 Feb 2021 22:00:00 -0000

ros-dashing-realsense2-camera (3.1.3-1bionic) bionic; urgency=high

  * Publish depth confidence image for supporting devices (L515)
  * fix bug: dynamic tf publisher.
  * fix realsense2_description's dependency to realsense2_camera_msgs
  * remove boost dependency.
  * rename node_namespace to namespace
  * rename node_executable to executable
  * Contributors: doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Sun, 27 Dec 2020 22:00:00 -0000

ros-dashing-realsense2-camera (3.1.2-1bionic) bionic; urgency=high

  * upgrade librealsense2 version to 2.40.0
  * Added pointcloud attributes, when RS2_STREAM_ANY is enabled
  * colorize the aligned depth image.
    fix missing parameters description.
  * add infra_rgb option: enable streaming D415's infra stream as RGB.
    Expose stereo extrinsics
    Avoid currently unsupported Z16H depth format.
    Enable launch cmd line params
    Add notification if connected using USB2.1 port.
  * Fix README.md
  * Add launch option: output:=[screen|log]: enable sending logs to ros log file.
  * rename rs.d400_and_t265.launch.py to rs_d400_and_t265_launch.py
    add rs_multi_camera_launch.py on top of rs_launch.py
  * Remove '_' prefix from parameter serial_no. Allow to pass serial_no which is sometimes a string containing only digits.
  * remove redundant nav_msgs dependency (caused build error)
  * remove node package, change msg package name
  * update README.md
  * Contributors: Ryan Shim, doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Wed, 09 Dec 2020 22:00:00 -0000

ros-dashing-realsense2-camera (3.1.1-1bionic) bionic; urgency=high

  * fix bug: Conversion from milliseconds to nanoseconds.
    enable use of parameter: use_sim_time.
  * various fixes for canonical ROS2
  * Contributors: AustinDeric, doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 22 Sep 2020 21:00:00 -0000

ros-dashing-realsense2-camera (3.1.0-1bionic) bionic; urgency=high

  * port support of T265 from ROS1.
  * Contributors: doronhi

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 15 Sep 2020 21:00:00 -0000

ros-dashing-realsense2-camera (3.0.0-1bionic) bionic; urgency=high

  * Update README.md
  * Enable recovery from reconnect event.
  * Add an example config file: d435i.yaml.
  * fix launch file installation. Allow running the following command: 'ros2 launch realsense2_camera rs.launch.py'
  * enable set_auto_exposure_roi options.
  * enable sensors and filters dynamic parameters.
  * clean
  * RealSenseNodeFactory inherits from rclcpp::Node
  * Add project: realsense2_node
  * Add support for D455
  * README.md: update installation process.

 -- Doron Hirshberg <doron.hirshberg@intel.com>  Tue, 15 Sep 2020 21:00:00 -0000

=== debian/control ===
Source: ros-dashing-realsense2-camera
Section: misc
Priority: optional
Maintainer: Doron Hirshberg <doron.hirshberg@intel.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libopencv-dev, ros-dashing-ament-cmake, ros-dashing-ament-cmake-gtest, ros-dashing-ament-lint-auto, ros-dashing-ament-lint-common, ros-dashing-builtin-interfaces, ros-dashing-cv-bridge, ros-dashing-geometry-msgs, ros-dashing-image-transport, ros-dashing-librealsense2, ros-dashing-nav-msgs, ros-dashing-rclcpp, ros-dashing-rclcpp-components, ros-dashing-realsense2-camera-msgs, ros-dashing-ros-environment, ros-dashing-sensor-msgs, ros-dashing-std-msgs, ros-dashing-std-srvs, ros-dashing-tf2, ros-dashing-tf2-ros, ros-dashing-ros-workspace
Homepage: http://www.ros.org/wiki/RealSense
Standards-Version: 3.9.2

Package: ros-dashing-realsense2-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-dashing-builtin-interfaces, ros-dashing-cv-bridge, ros-dashing-geometry-msgs, ros-dashing-image-transport, ros-dashing-launch-ros, ros-dashing-librealsense2, ros-dashing-nav-msgs, ros-dashing-rclcpp, ros-dashing-rclcpp-components, ros-dashing-realsense2-camera-msgs, ros-dashing-sensor-msgs, ros-dashing-std-msgs, ros-dashing-std-srvs, ros-dashing-tf2, ros-dashing-tf2-ros, ros-dashing-ros-workspace
Description: RealSense Camera package allowing access to Intel SR300, D400 and L500 3D cameras

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing" \
		-DCMAKE_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-realsense2-camera//opt/ros/dashing/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
